// $Id: CHANGELOG.txt,v 1.1.2.15 2010/08/23 14:24:39 yhahn Exp $

features DRUPAL-6--1-0
----------------------
- No changes from RC3.

features DRUPAL-6--1-0-RC3
--------------------------
- Ensure feature module name is properly handled in AHAH callback.
- #577852: Do not allow module to add itself as dependency.

features DRUPAL-6--1-0-RC2
--------------------------
- #888066 by ptrl: Views message typo.
- #884624: Better support for custom CTools export callbacks.

features DRUPAL-6--1-0-RC1
--------------------------
- #878604 by Coornail: Fix for PHP notice.
- Add < and > to the list of characters that must be DOM encoded for AHAH safe
  handling.
- #878068: escape component identifiers.
- #880456: Fix for PHP notice.
- #880186 by yhahn, loosening the iron grip on vocabulary machine names.
- #881010: Properly refer to menu links when doing a ordered build.

features DRUPAL-6--1-0-BETA12
-----------------------------
- #873570: DOM-safe encode #default_value and ecsape '.' character.
- #872052: Expose CCK field instances in UI for export.
- Use README.txt for hook_help() page.
- #872482: Proper failure for features_get_features().
- #875156: Ensure roles are rebuilt before permissions.
- #875416: Less confusing export of translatables.
- #877178: Allow feature human-readable name/description to be changed on recreate.
- #722952: Only write 'project' key if version or update status URL are provided.
- #876206 by auzigog: Document hook_[component_defaults]_alter() functions.

features DRUPAL-6--1-0-BETA11
-----------------------------
- #865454: Fix for complex menu links component handling.
- Context: simpler check for API version
- Blank out .features.inc when appropriate when updating existing features.
- Fix for haphazard drush features-revert.
- Adjust features_get_component_map() to allow for easy retrieval of a specific
  component key.

features DRUPAL-6--1-0-BETA10
-----------------------------
- #864742: Ensure CTools plugins.inc is included before calling API functions.
- #864482 by hadsie: Fix for PHP notice.
- Fix Views dependency detection.

features DRUPAL-6--1-0-BETA9
----------------------------
This release introduces several important API and component changes.

### Include file writing

- CTools and Views components are now written to supported API include files,
  e.g. `[myfeature].views_default.inc` and `[myfeatures].[ctools api].inc`.
- Features-supported faux-exportable components are written to distinct include
  files, e.g. `[myfeature].features.[component].inc`.
- Only API hooks and hooks for APIs that do not handle file inclusion should be
  written to `[myfeatures].features.inc` which is loaded by default through the
  feature module file. These include `hook_views_api`, `hook_ctools_api`,
  `hook_node_info`, etc.
- All features using the old include formats are still supported but many
  components will be marked as 'Overridden' until the feature is updated.
- `[myfeature].defaults.inc`, `[myfeature].features.node.inc` and
  `[myfeature].features.views.inc` are deprecated and can be safely removed
  after the feature has been updated.

### Component API changes

- An exportable taxonomy vocabulary component has been introduced which uses
  the `module` column of the vocabulary table as storage for machine names.
- The menu component has been deprecated in favor of more advanced `menu_links`
  and `menu_custom` components. Features using the old `menu` component can be
  migrated to the new components through a feature update.
- The old user permission component has been deprecated in favor of the
  `user_permission` and `user_role` components. Features will no longer
  automatically create roles that do not exist -- they must be exported
  properly using the `user_role` component. Features using the old `user`
  component can be migrated to the new components through a feature update.

- FIx for features implementers using FEATURES_DEFAULTS_CUSTOM.
- #504706 by dmitrig01: Recreate: include any additional files from the original
  feature
- #728004 by gordon, dmitrig01: Allow abitrary modules to alter the pipeline.
- #752144 by dmitrig01: Refactor Features Status Page for Performance
- #841844 by dmitrig01: Implement environment-agnostic message logging.
- #577674 by dmitrig01: Display reasons for Incompatible Feature.
- #838726: Fix possible creation of circular dependencies by cross-feature
  fields.
- #829778 by Josh Waihi: Add features-diff command.
- Fix for reckless iteration.
- Make features component options DOM safe for AHAH handling.
- #717152 by dmitrig01: Ensure dependent features cannot be disabled.
- Strip tags when displaying log messages in CLI.
- #823278 by Grayside: Display warning when feature .module does not include
  .feature.inc.
- #649604: Split out dependencies as a component, proper, and ensure that
  feature dependencies are met.
- #742940: Improve granularity and compatibility of Features export includes.
- #741498: Fix for bad function signature.
- Suppress PHP 5.3 errors/warnings when generating tar output.
- #813960 by nyl auster: Make it possible to revert defaulted features with
  --force
- Massive update to README.txt.
- #843956 by q0rban: Drush commands use deprecated callback names
- #829778 by q0rban: Offer to download and install diff if it is not available.
- #843106 by dmitrig01: Check hook_requirements.
- Updating API.txt
- #843106 by dagmar: Fix for hook_requirements() checking.
- Adding a note about custom code to README.txt
- #789556 by alex_b, yhahn, bcmiller0 and jmiccolis, Support taxonomy
  vocabularies.
- Adding hook help.
- #853738 by fgm: Fix for reckless check against ['default_file']
- #852704 by q0rban: Check if Taxonomy exists before piping.
- #633804 by catch, dereine, yhahn, JohnAlbin: Improve menu support
- Ensure feature component options are escaped.
- #792790 by Dustin Currie: Fix label for components editing.
- Cleanup display of components on create/reexport.
- Fix for PHP notice.
- Fix for export and allow drush fu to affect modules in "non-standard"
  directories.
- Fix PHP notice when description is not set.
- Fix for PHP notice.
- Reduce excessive cache clearing.
- Refactor features_get_default() and introduce features_get_default_map() to
  simplify implementers' code.
- Update to features_test module.
- Remove misleading log messages.
- #830774 by scottrigby: Fix for reckless iteration.
- #751538 by DeFr: Clear caches after batch revert of Views rather than
  individually.
- #678930 by tim.plunkett: Fix Features package tab sorting.
- Die tabs.
- Remove confusing debug output for revert.
- Don't run the bulk of feature generation/export logic unless we're sure the
  feature can be written.
- Check that specified object is loaded before attempting export.
- #693024 by ceardach, hefox, nedjo: Add alter hooks for faux exportables.
- Only write Views API hook if views are actually exported.
- Fix for bad params.
- Removing excessive taxonomy pipe from node component.
- Preserve selected values even if form fails to validate.
- #849646: CTools: fix for integration with page manager list callback.
- #553866: Split user component into user_roles, user_permissions.
- #650292: Limit export options to normal and current feature's components.
- Fixing user permission test.
- Remove special handling for menu component.
- #649298 by q0rban, KarenS, yhahn: Allow node component type revert to disable
  extra CCK fields.
- Cleaning up function signatures.

features DRUPAL-6--1-0-BETA8
----------------------------
- #814414: Fix context integration to properly integrate with CTools.
- #810958 by q0rban: Add censored expletives to my daily workflow.

features DRUPAL-6--1-0-BETA7
----------------------------
- #778250: Fix for php 5.3 issue with CTools.
- Added static cache to ensure features_include() runs only once.
- #522794 by Skorpjon, kenorb: Fixes for tar archive creation.
- #686240 by David Stosik: Ensure field settings are properly captured accross
  instances.
- Add the drush features-update-all command and switch to using
  drush_invoke_backend() to ensure processes have a better memory footprint.
- Standardize CTools API identifier to fully support non-exportables CTools
  APIs.
- Ensure dependencies added by CTools do not create circular dependencies.
- #798104 by Steven Merrill: Add drush features-revert-all command.
- #673234 by joshk: Use elseif instead of else if to comply with coding
  standards.
- Support additional CTools plugin APIs that are non-exportable based.
- #722460 by scor: Use 'drupal dependencies' flag in hook_drush_command() to
  ensure features is enabled.
- #727110 by adixon: Respect drush --root option.
- #726700: Context 3.x dependency & component detection.
- #709608: CTools: don't re-export objects that already exist in code. Depends
  on #709754.
- Disable features before installing on submit.
- #725132 by q0rban: Fix for fieldgroup duplicate entries.

features DRUPAL-6--1-0-BETA6
----------------------------
- #640438: Ensure new features are not created in existing local namespaces.
- #706950: Fieldgroup component test.
- #696554 by Amitaibu: Add --force option to features-revert command.
- #702418 by Haza: Ensure roles are not localized on export when originating
  from filter formats.
- #480978 by q0rban: Add fieldgroup support.
- #680332 by christianchristensen: Ensure each perm has only one instance of
  each role.
- #693944: Use strongarm to export CCK extra field weights.
- #678930: Sort package links.
- #670788 by jasonitti, andrewfn, irakli: Fix for regex syntax error in PHP
  <= 5.2.2
- Use human readable names for dependencies.
- CTools: Show human readable names for components.
- #691894: Use human readable names on component display.
- #682730: Ensure object exists before attempting to render export code.
- #682730: Using API owner with schema owner as module fallback.
- #696396 by irakli: sort ctools exportables alphabetically.
- #694890: Ensure rebuild menu reflects node types
- Check that a feature has dependencies before trying to maximize them.
- by mig5, Amitaibu: Update drush commands to use dashes.
- Init component states array for each feature.
- Removing features_menu_links() hack in favor of implementers using a
  preprocess_page() function directly.
- by Zoltán Balogh: Updated Hungarian translation.
- #675306: Prevent feaures_detect_overrides() from running unless user is
  properly permissioned.

features DRUPAL-6--1-0-BETA5
----------------------------
- Basic component functional API tests.
- A variety of static cache clears added -- discovered through tests.
- #649410: Ensure cleanup doesn't disable Features module.
- #654334: Allow feature builders to override module key of hook_node_info().
- #622346: Make use of drush_log for assertions.
- #656172: Delete features menu on uninstall.
- #577852: Don't allow feature module to add itself as a dependency.
- #660798 by e2thex: Use key from ctools_export_load_object.
- CTools: Only export objects that can be loaded.
- CTools: Implement hook_features_api() using component's module namespace
  rather than the component namespace.
- Only load includes on behalf of modules not implementing hook_features_api.
- #532256 by flobruit and jmiccolis, more robust support for ctools
  exportables, like panels.
- Adding component revert for ctools.features.ctools.inc
- #641658 by brad bulger: Fix for reckless ->delete() View method call.
- #649832 by DamienMcKenna: Fix message on Views revert.
- #653644, #532646 by careernerd, q0rban: Revert/update multiple features at
  once.

features DRUPAL-6--1-0-BETA4
----------------------------
Note: You MUST run update.php for Features to begin automatically rebuilding
feature components when safe to do so.

This release of Features contains a lot of new features and many changes to the
internals for rebuildable components. There are no major API changes but as
always please test thoroughly in a staging environment before rolling out beta4
to production sites.

- #616222: Moving conflict detection API functions into module proper.
- #520220: Allow modules to be ignored when cleaning up dependencies.
- #597330 by fago, fixed display of rule names in feature building ui.
- #616222 by q0rban: API function for installing maximum dependencies of
  modules/features.
- #606992 by dmitrig01: Human readable names for feature components.
- #612824: Proper handling of rebuildables & component reverting. Reported by
  greggles, Roger Saner.
- #616030 by q0rban: Simplify access check against features administration pages.
- #597836: Remove form_alter() which hides features from admin/build/modules.
- 3 stage state signature handling.
- #597422 by Roger López: Consistify user permission, role sorting.
- #522794 by Steven Merrill: Clear output buffer before transfering tgz file.
- #604138 by Josh Waihi: Check for array before beginning reckless iteration.
- by Istvan Palocz (pp): Hungarian translation
- #521394: Initial implementation of features packages.
- #520220: Provide form for disabling orphaned feature dependencies.
- #520310: Adds implementation of 'administer features' and 'manage features'
  permissions.
- #402132: Adding validation checks to features create form.
- Improved UI.
- Cleanup rebuild/revert stack for CCK, filter formats, user permissions.
- Simpler revert logic and sanitization of imagecache export presets.
- #581514 by q0rban: Set a destination for feature revert links.
- #401948 by derhasi: Export help and min_word_count values for node types.
- #583120: Check for menu_custom table before querying.
- #586634 by Pasqualle, prevent empty t() calls in exports.
- #588808 by Pasqualle, php notice fix.
- Sorting permissions on export to maintain array consistency.

features DRUPAL-6--1-0-BETA3
----------------------------
This release of Features contains several key changes - if you are using
Features in production you should be cautious of upgrading without testing.

Previous releases of features contained an error in integration with the
node module - the module key of hook_node_info() should now be features
rather than node. Features will do this update for you automatically if
you use drush features update or update your feature through the UI.
You will still need to run features_update_6100() from update.php to
update the node type entries in your database. For more information
about this issue see http://drupal.org/node/521606.

- Using correct API identifier for CTools integration.
- Allowing modules that implement hook_system_info_alter() to modify the
  features info cache as well.
- #532256 by flobruit: Use proper ctools API functions for schema retrieval and
  object export.
- #551490 by fago, Allow renaming of components.
- Fixing bad FormAPI key ['#redirect']
- #521606 by mig5, q0rban: Correct hook_node_info() 'module' attribute to remove
  feature node types when feature is disabled.
- Fix for node type export check which should now include 'features' as an
  acceptable module for node type exports.

features DRUPAL-6--1-0-BETA2
----------------------------
- #560478 by jose reyero and myself, support translated role names.
- #557112 by moshe weitzman: Suppress unnecessary menu_rebuild()'s.

features DRUPAL-6--1-0-BETA1
----------------------------
This release of Features makes an API change to hook_features_api().
Please see API.txt for the details.

- Improving cache clear flow after feature is enabled.
- #511872 by TUc: Fix typo in hook comment.
- Fix for long feature name/descriptions breaking float in feature form.
- #522820 by fago: Allow multiple components per module.
- #520376: Adding static cache to override access check to prevent recursion.
- #524124 by fago: Only include features includes for modules when they are
  enabled.
- #524160 by fago: Allow one default hook to contain multiple components.
- by dmitrig01: Add a static cache to features_get_info()
- #532256 ctools integration by alex_b and yhann.
- #543190 by jmiccolis: Refactor hook_features_api() for greater extensibility
  and multi-inc file export.
- #527646 by Amitaibu: Add user_features_export_options().
- #545276 by q0rban: Check for field existence before updating CCK fields when
  reverting.
- #543152 by q0rban: Fix for views export detection error.
- Refactoring override detection code and export/build process.
- Correctly excluded added dependencies from feature component array in info
  file.
- Adding configurable duplicate handling and allowing CTools API components to
  be duplicated across features.
- Ensure that dependencies are unique.

features DRUPAL-6--1-0-ALPHA5
-----------------------------
- Implementing project status url and version keys in info files.
- Removed context dependency.
- Implementing feature reverting in the UI and some admin UI cleanups.
- Initial commit of experimental user/permission integration.
- Initial commit of features-filters integration.
- Corrected a misnamed drush hook.
- Updated usage of drush_print_table to reflect recent changes in drush.
- Adding component conflict detection between features.
- Adding export for translatable strings in menu, CCK.
- #483548 by jmiccolis: Use AJAX to lighten server load on feature
  overview page.

features DRUPAL-6--1-0-ALPHA4
-----------------------------
- Ensure that a feature module cannot create circular dependencies.
- #482212 by rszrama: Displaying a friendly message when no features
  are available.
- Move all theme functions into theme.inc.
- Allow any implementing module to specify itself as a feature source.
- Improve handling of include files.
- Added hook_features_api() for declaring various info.
- Show options for any implementer that provides export options on the
  feature component confirmation form.
- Fixing issue where only 1st level dependencies were enabled when
  enabling a feature.
- Clearing caches after features form submission using
  hook_flush_caches() rather than piecemeal.

features DRUPAL-6--1-0-ALPHA3
-----------------------------
- Removing field updating nonsense from field rebuilding --
  moved to revert hooks.
- Renaming drush command 'status features' to 'features'.
- #441826: Fix for improper escaping of single quotes.
- #449916 by Steven Jones: Checks that implementations of
  hook_views_default_views() actually return an array of views before
  iterating.
- #440592 by benroot: Feature component reverting through drush.
- Adding headers to diff table.

features DRUPAL-6--1-0-ALPHA2
-----------------------------
- #421740: Fix for context pipe with views displays.
- #430044: Fixing dependency checking in content and context includes.
- Flushing caches before drush export.
- Adding export item sorting for code stability.
- Smarter export detection and dependency handling to imagecache.
- Fix for imagecache export render.
- Adding implementation of hook_flush_caches().

features DRUPAL-6--1-0-ALPHA1
-----------------------------
- Initial release of features module.
